hdu5336 多校联合第四场1010 模拟+bfs优先队列

http://acm.hdu.edu.cn/showproblem.php?pid=5336

Problem Description
XYZ is playing an interesting game called "drops". It is played on a  rc  grid. Each grid cell is either empty, or occupied by a waterdrop. Each waterdrop has a property "size". The waterdrop cracks when its size is larger than 4, and produces 4 small drops moving towards 4 different directions (up, down, left and right). 

In every second, every small drop moves to the next cell of its direction. It is possible that multiple small drops can be at same cell, and they won't collide. Then for each cell occupied by a waterdrop, the waterdrop's size increases by the number of the small drops in this cell, and these small drops disappears. 

You are given a game and a position ( x y ), before the first second there is a waterdrop cracking at position ( x y ). XYZ wants to know each waterdrop's status after  T  seconds, can you help him?

1r100 1c100 1n100 1T10000
 

Input
The first line contains four integers  r c n  and  T n  stands for the numbers of waterdrops at the beginning. 
Each line of the following  n  lines contains three integers  xi yi sizei , meaning that the  i -th waterdrop is at position ( xi yi ) and its size is  sizei . ( 1sizei4 )
The next line contains two integers  x y

It is guaranteed that all the positions in the input are distinct. 

Multiple test cases (about 100 cases), please read until EOF (End Of File).
 

Output
n  lines. Each line contains two integers  Ai Bi
If the  i -th waterdrop cracks in  T  seconds,  Ai=0 Bi=  the time when it cracked. 
If the  i -th waterdrop doesn't crack in  T  seconds,  Ai=1 Bi=  its size after  T  seconds.
 

Sample Input
  
  
4 4 5 10 2 1 4 2 3 3 2 4 4 3 1 2 4 3 4 4 4
 

Sample Output
  
  
0 5 0 3 0 2 1 3 0 1
/**
hdu5336 多校联合第四场1010   模拟+bfs
题目大意:很像一个游戏“十滴水”,在一个n*m的棋盘里有N个点有一些水滴,含水量为1~4,如果一滴水多于4则该水滴会向四个方向放射量为1
          的水,并且原位置水滴消逝,放射的水运动速度为1格/s,最开始在xy位置有一滴水崩裂,问T s时各初始状态的水滴的状态是什么
解题思路:因为水滴的迸射会产生连锁反应,因此我们用优先队列维护,bfs。
          值得一提的是如果2或以上的水同时到达一水滴,并该水滴迸射那么这些水滴同时消失。
*/
#include <string.h>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <queue>
using namespace std;
int n,m,N,T,num[1005][2],sta[1005][1005],time[1005][1005];
int dx[][2]= {1,0,0,1,-1,0,0,-1};
struct note
{
    int x,y,d,t;
    note() {}
    note(int _x,int _y,int _d,int _t)
    {
        x=_x,y=_y,d=_d,t=_t;
    }
    bool operator < (const note &other)const
    {
        return t>other.t;
    }
};

void bfs(int x,int y)
{
    memset(time,-1,sizeof(time));
    priority_queue<note> q;
    q.push(note(x,y,0,0));
    q.push(note(x,y,1,0));
    q.push(note(x,y,2,0));
    q.push(note(x,y,3,0));
    while(!q.empty())
    {
        note cnt=q.top();
        if(cnt.t>=T)return;
        q.pop();
        x=cnt.x+dx[cnt.d][0];
        y=cnt.y+dx[cnt.d][1];
        if(x<=0||x>n||y<=0||y>m||time[x][y]==cnt.t+1)continue;
        if(sta[x][y]!=0)
        {
            if(sta[x][y]==4)
            {
                sta[x][y]=0;
                time[x][y]=cnt.t+1;
                q.push(note(x,y,0,cnt.t+1));
                q.push(note(x,y,1,cnt.t+1));
                q.push(note(x,y,2,cnt.t+1));
                q.push(note(x,y,3,cnt.t+1));
            }
            else
            {
                sta[x][y]++;
            }
        }
        else
            q.push(note(x,y,cnt.d,cnt.t+1));
    }
}
int main()
{
    while(~scanf("%d%d%d%d",&n,&m,&N,&T))
    {
        memset(sta,0,sizeof(sta));
        for(int i=0; i<N; i++)
        {
            int x;
            scanf("%d%d%d",&num[i][0],&num[i][1],&x);
            sta[num[i][0]][num[i][1]]=x;
        }
        int x,y;
        scanf("%d%d",&x,&y);
        bfs(x,y);
        for(int i=0; i<N; i++)
        {
            if(time[num[i][0]][num[i][1]]==-1)
                printf("1 %d\n",sta[num[i][0]][num[i][1]]);
            else
                printf("0 %d\n",time[num[i][0]][num[i][1]]);
        }
    }
    return 0;
}


对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)加入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别加上a[i],然后再将加和的结果作为新的候选值加入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有加和结果作为新的候选值加入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值